--- a/contrib/Makefile
+++ b/contrib/Makefile
@@ -5,64 +5,10 @@
 include $(top_builddir)/src/Makefile.global
 
 SUBDIRS = \
-		adminpack	\
-		auth_delay	\
-		auto_explain	\
-		btree_gin	\
-		btree_gist	\
-		chkpass		\
-		citext		\
-		cube		\
-		dblink		\
-		dict_int	\
-		dict_xsyn	\
-		dummy_seclabel	\
-		earthdistance	\
-		file_fdw	\
-		fuzzystrmatch	\
-		hstore		\
-		intagg		\
-		intarray	\
-		isn		\
-		lo		\
-		ltree		\
 		oid2name	\
-		pageinspect	\
-		passwordcheck	\
-		pg_archivecleanup \
-		pg_buffercache	\
-		pg_freespacemap \
-		pg_prewarm	\
-		pg_standby	\
-		pg_stat_statements \
-		pg_test_fsync	\
-		pg_test_timing	\
-		pg_trgm		\
-		pg_upgrade	\
-		pg_upgrade_support \
 		pgbench		\
-		pgcrypto	\
-		pgrowlocks	\
-		pgstattuple	\
-		pg_xlogdump	\
-		postgres_fdw	\
-		seg		\
-		spi		\
-		tablefunc	\
-		tcn		\
-		test_decoding	\
-		test_parser	\
-		test_shm_mq	\
-		tsearch2	\
-		unaccent	\
-		vacuumlo	\
-		worker_spi
+		vacuumlo
 
-ifeq ($(with_openssl),yes)
-SUBDIRS += sslinfo
-else
-ALWAYS_SUBDIRS += sslinfo
-endif
 
 ifneq ($(with_uuid),no)
 SUBDIRS += uuid-ossp
--- a/src/backend/Makefile
+++ b/src/backend/Makefile
@@ -47,7 +47,7 @@
 
 ##########################################################################
 
-all: submake-libpgport submake-schemapg postgres $(POSTGRES_IMP)
+all: someheaders
 
 ifneq ($(PORTNAME), cygwin)
 ifneq ($(PORTNAME), win32)
@@ -106,7 +106,7 @@
 endif # aix
 
 # Update the commonly used headers before building the subdirectories
-$(SUBDIRS:%=%-recursive): $(top_builddir)/src/include/parser/gram.h $(top_builddir)/src/include/catalog/schemapg.h $(top_builddir)/src/include/utils/fmgroids.h $(top_builddir)/src/include/utils/errcodes.h $(top_builddir)/src/include/utils/probes.h
+someheaders $(SUBDIRS:%=%-recursive): $(top_builddir)/src/include/parser/gram.h $(top_builddir)/src/include/catalog/schemapg.h $(top_builddir)/src/include/utils/fmgroids.h $(top_builddir)/src/include/utils/errcodes.h $(top_builddir)/src/include/utils/probes.h
 
 # run this unconditionally to avoid needing to know its dependencies here:
 submake-schemapg:
@@ -199,23 +199,7 @@
 
 ##########################################################################
 
-install: all installdirs install-bin
-ifeq ($(PORTNAME), cygwin)
-ifeq ($(MAKE_DLL), true)
-	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
-endif
-endif
-ifeq ($(PORTNAME), win32)
-ifeq ($(MAKE_DLL), true)
-	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
-endif
-endif
-	$(MAKE) -C catalog install-data
-	$(MAKE) -C tsearch install-data
-	$(INSTALL_DATA) $(srcdir)/libpq/pg_hba.conf.sample '$(DESTDIR)$(datadir)/pg_hba.conf.sample'
-	$(INSTALL_DATA) $(srcdir)/libpq/pg_ident.conf.sample '$(DESTDIR)$(datadir)/pg_ident.conf.sample'
-	$(INSTALL_DATA) $(srcdir)/utils/misc/postgresql.conf.sample '$(DESTDIR)$(datadir)/postgresql.conf.sample'
-	$(INSTALL_DATA) $(srcdir)/access/transam/recovery.conf.sample '$(DESTDIR)$(datadir)/recovery.conf.sample'
+install:
 
 install-bin: postgres $(POSTGRES_IMP) installdirs
 	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postgres$(X)'
--- a/src/bin/Makefile
+++ b/src/bin/Makefile
@@ -13,8 +13,7 @@
 top_builddir = ../..
 include $(top_builddir)/src/Makefile.global
 
-SUBDIRS = initdb pg_ctl pg_dump \
-	psql scripts pg_config pg_controldata pg_resetxlog pg_basebackup
+SUBDIRS = pg_dump psql scripts pg_config
 
 ifeq ($(PORTNAME), win32)
 SUBDIRS += pgevent
--- a/src/Makefile
+++ b/src/Makefile
@@ -15,18 +15,11 @@
 SUBDIRS = \
 	common \
 	port \
-	timezone \
 	backend \
-	backend/utils/mb/conversion_procs \
-	backend/snowball \
 	include \
 	interfaces \
-	backend/replication/libpqwalreceiver \
 	bin \
-	pl \
-	makefiles \
-	test/regress \
-	test/perl
+	makefiles
 
 # There are too many interdependencies between the subdirectories, so
 # don't attempt parallel make here.
